import static com.kms.katalon.core.checkpoint.CheckpointFactory.findCheckpoint
import static com.kms.katalon.core.testcase.TestCaseFactory.findTestCase
import static com.kms.katalon.core.testdata.TestDataFactory.findTestData
import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject
import com.kms.katalon.core.checkpoint.Checkpoint as Checkpoint
import com.kms.katalon.core.cucumber.keyword.CucumberBuiltinKeywords as CucumberKW
import com.kms.katalon.core.mobile.keyword.MobileBuiltInKeywords as Mobile
import com.kms.katalon.core.model.FailureHandling as FailureHandling
import com.kms.katalon.core.testcase.TestCase as TestCase
import com.kms.katalon.core.testdata.TestData as TestData
import com.kms.katalon.core.testdata.InternalData as ID
import com.kms.katalon.core.testobject.TestObject as TestObject
import com.kms.katalon.core.webservice.keyword.WSBuiltInKeywords as WS
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI
import internal.GlobalVariable as GlobalVariable
import org.openqa.selenium.Keys as Keys
import org.openqa.selenium.By as By
import org.openqa.selenium.WebDriver as WebDriver
import org.openqa.selenium.WebElement as WebElement
import com.kms.katalon.core.webui.driver.DriverFactory as DriverFactory
import com.kms.katalon.core.webui.common.WebUiCommonHelper as WebUiCommonHelper

WebDriver driver = DriverFactory.getWebDriver()

TestData data = findTestData('DocQty')

println(data.getColumnNames())

'Refernce Value Date'
Date date = new Date()

String RefDate = date.format('yyyy-MMdd')

'Wip Package Execution Date'
String ExecDate = date.format('MM/dd/yyyy')

'this is to set how many runs this script will conduct.'
int max = GlobalVariable.refStartNum + GlobalVariable.pkgCount

if (GlobalVariable.refStartNum == 0) {
    max = (max - 1)
}

println((('Total Package Count: ' + GlobalVariable.pkgCount) + 'max?') + max)

//navigate from the home page to the main page
WebUI.navigateToUrl('https://staging.erecordingpartners.net/eCourier/WebUI/IndexWipPackage')

// loop for multiple packages
//for (GlobalVariable.refStartNum; GlobalVariable.refStartNum <= max; (GlobalVariable.refStartNum)++) {
println(data.getRowNumbers())

for (def index : (1..data.getRowNumbers())) {
    WebUI.waitForJQueryLoad(45, FailureHandling.STOP_ON_FAILURE)

    //Select New Wip Package
    if (GlobalVariable.User == 0) {
        WebUI.click(findTestObject('Staging/Page_IndexWipPackage - eRecording/a_New WIP Package (KL)') //Once Object Spy is functioning again, this needs to be the button location for AEspargaro
            )
    } else if (GlobalVariable.User == 2) {
        WebUI.click(findTestObject('Staging/Page_IndexWipPackage - eRecording/a_New WIP Package (AI)'))
    } else if (GlobalVariable.User == 3) {
        WebUI.click(findTestObject('Staging/Page_IndexWipPackage - eRecording/a_New WIP Package (AE)'))
    }
    
    Math.random()

    WebUI.waitForPageLoad(20)

    'Logged in using kleishman or aiannone for the KTM client.'
    if ((GlobalVariable.User == 0) || (GlobalVariable.User == 2)) {
        'Select State'
        GlobalVariable.state = 0 //((Math.random() * 3) as int)

        println('State Selected: ' + GlobalVariable.state)

        if (GlobalVariable.state == 0) {
            WebUI.selectOptionByIndex(findTestObject('Staging/Page_NewWipPackage - eRecording/select_Please select..FloridaM'), 
                1)
        } else if (GlobalVariable.state == 1) {
            WebUI.selectOptionByIndex(findTestObject('Staging/Page_NewWipPackage - eRecording/select_Please select..FloridaM'), 
                2)

            WebUI.delay(3)

            'Select Jurisdiction'
            GlobalVariable.rJ = ((Math.random() * 10) as int)

            WebUI.selectOptionByIndex(findTestObject('Object Repository/Page_NewWipPackage - eRecording/select_Please select..AnokaBe'), 
                GlobalVariable.rJ)
        } else if (GlobalVariable.state == 2) {
            WebUI.selectOptionByIndex(findTestObject('Staging/Page_NewWipPackage - eRecording/select_Please select..FloridaM'), 
                3)

            WebUI.delay(3)

            'Select Jurisdiction'
            GlobalVariable.rJ = ((Math.random() * 3) as int)

            WebUI.selectOptionByIndex(findTestObject('Object Repository/Page_NewWipPackage - eRecording/select_Please select..KingPie'), 
                GlobalVariable.rJ)
        }
    }
    
    'Reference Value Parameters'

    'Create dynamic Ref Value based on date'
    println(GlobalVariable.refStartNum)

    if (GlobalVariable.refStartNum < 10) {
        WebUI.setText(findTestObject('Staging/Page_New ePN Package - eRecording/input__RefValue (1)'), (RefDate + '-00') + 
            Integer.toString(GlobalVariable.refStartNum))
    } else if (GlobalVariable.refStartNum >= 10) {
        WebUI.setText(findTestObject('Staging/Page_New ePN Package - eRecording/input__RefValue (1)'), (RefDate + '-0') + 
            Integer.toString(GlobalVariable.refStartNum))
    }
    
    (GlobalVariable.refStartNum)++

    println(GlobalVariable.refStartNum)

    'Enter Ref Value 2'
    WebUI.setText(findTestObject('Staging/Page_New ePN Package - eRecording/input__RefValue2 (1)'), GlobalVariable.RefValue2)

    'Save Package Details'
    WebUI.click(findTestObject('Staging/Page_NewWipPackage - eRecording/a_Save'))

    //if the user is AEspargaro with the Aprilia client, used for paper packages where appropriate
    'Package Building'

    '::Applied Functioning Code::'
    if (!(GlobalVariable.TestRun)) {
        'Page Loads'

        'Doc Count Random: Setup'

        /*GlobalVariable.docCount = ((Math.random() * 4) as int)
		//check to make sure doc count is not 0 when randomized. Create a maxmin random.
		if(GlobalVariable.docCount<1){GlobalVariable.docCount==1}
		println('Package Documents: '+GlobalVariable.docCount)*/
        //docCount needs to be taken from variable that uses data set
		
        'Document Build Loop'
        println('Documents to be created? '+data.getValue('Doc Qty', index))

        for (int i = 1; i <= data.getValue('Doc Qty', index); i++) {
            println(i)

            'Dynamically select docType'
            WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__TTextDropdown_1'))

            WebUI.delay(1)

            List<WebElement> listElements = WebUiCommonHelper.findWebElements(findTestObject('Object Repository/docTypeList'), 
                30)

            WebElement docTypeSelect = listElements.get(new Random().nextInt(listElements.size()))

            docTypeSelect.click()

            println(docTypeSelect.getText())

            /*for(WebElement w : listElements) {
				println(w.getText());
			}*/
            //WebUI.click(findTestObject('Staging/Page_DynamicWipDoc - eRecording/li_Mortgage'), FailureHandling.STOP_ON_FAILURE)
            WebUI.delay(5)

            //Create a new folder with many different file types. Randomize which file is selected and Uploaded.
            'Upload file'
            if (i == 1) {
                WebUI.uploadFile(findTestObject('Staging/Page_DynamicWipDoc - eRecording/input__btnFileUpload'), 'C:\\\\Users\\\\kleishman\\\\Pictures\\\\Document Samples\\\\Sample_DeathCert.tif', 
                    FailureHandling.STOP_ON_FAILURE)
            } else if (i == 2) {
                WebUI.uploadFile(findTestObject('Staging/Page_DynamicWipDoc - eRecording/input__btnFileUpload'), 'C:\\\\Users\\\\kleishman\\\\Pictures\\\\Document Samples\\\\doc_bulkupload.pdf', 
                    FailureHandling.STOP_ON_FAILURE)
            } else if (i > 2) {
                WebUI.uploadFile(findTestObject('Staging/Page_DynamicWipDoc - eRecording/input__btnFileUpload'), 'C:\\\\Users\\\\kleishman\\\\Pictures\\\\Document Samples\\\\NumberPages.pdf', 
                    FailureHandling.STOP_ON_FAILURE)
            }
            
            WebUI.waitForElementVisible(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/div_Apply fill-in locations'), 
                30, FailureHandling.STOP_ON_FAILURE)

            //This section needs to be customized depending on the document type
            'Enter Document Details'
            'Execution Date'
			WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__ExecutionDate'), 
                ExecDate, FailureHandling.STOP_ON_FAILURE)

            WebUI.sendKeys(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__ExecutionDate'), 
                Keys.chord(Keys.ENTER))

            'Consideration Amount'
			println(WebUI.verifyElementVisible(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__ConsiderationAmount')))
			if(WebUI.verifyElementVisible(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__ConsiderationAmount'))){
				
				WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__ConsiderationAmount'), 
                '300', FailureHandling.CONTINUE_ON_FAILURE)
            }
            
			'Pin'
            if(WebUI.verifyElementVisible(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__CountyDocTypeValuePin'))){
				WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__CountyDocTypeValuePin'), 
                '123456', FailureHandling.CONTINUE_ON_FAILURE)
            }
            WebUI.delay(4)

            'Save'
            //WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Save'))
			WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Save(DocSum)'), FailureHandling.CONTINUE_ON_FAILURE)
			println('Saved Document Summary')
            WebUI.delay(5)

            //Create a Data file with names to pull from for these.
            'Add Grantee'
            WebUI.selectOptionByIndex(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/select_Please select..GranteeG'), 
                1, FailureHandling.STOP_ON_FAILURE)

            WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__WipPartyViewModel.First'), 
                GlobalVariable.Grantee)

            WebUI.waitForElementClickable(findTestObject('Staging/Page_DynamicWipDoc - eRecording/a_Add(Parties)'), 30)

            WebUI.click(findTestObject('Staging/Page_DynamicWipDoc - eRecording/a_Add(Parties)'))
			println('Added Grantee')
            WebUI.delay(3)

            //Create a Data file with names to pull from for these.
            'Add Grantor'
            WebUI.selectOptionByIndex(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/select_Please select..GranteeG'), 
                2, FailureHandling.STOP_ON_FAILURE)

            WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__WipPartyViewModel.First'), 
                GlobalVariable.Grantor)

            WebUI.waitForElementClickable(findTestObject('Staging/Page_DynamicWipDoc - eRecording/a_Add(Parties)'), 30)

            WebUI.click(findTestObject('Staging/Page_DynamicWipDoc - eRecording/a_Add(Parties)'))
			println('Added Grantor')
            WebUI.delay(3)

            'Document Number'
            if(WebUI.verifyElementVisible(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__WipAssocDocViewModel.Do'), FailureHandling.CONTINUE_ON_FAILURE)){
				WebUI.setText(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/input__WipAssocDocViewModel.Do'), 
	                '123456',FailureHandling.CONTINUE_ON_FAILURE)
	            WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Add(AD)'),FailureHandling.CONTINUE_ON_FAILURE)
				println('Added Document Number')
	            WebUI.delay(3)
			}
            'Add additional documents'
            if ((data.getValue('Doc_Qty', index) > 1) && (i < data.getValue('Doc_Qty', index))) {
                WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Add New Document'))

                WebUI.delay(5)
            } else{FailureHandling.CONTINUE_ON_FAILURE}
			 /*if(GlobalVariable.docCount>1 && i <GlobalVariable.docCount){
				WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Add New Document'))
				WebUI.delay(5)
			}*/
        }
        
        WebUI.click(findTestObject('Object Repository/Staging/Page_DynamicWipDoc - eRecording/a_Close Package (APR)'))
    }
    
    '::Test Code::'
    if (GlobalVariable.TestRun) {
        break
    }
}

